- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::RegisteredOptions Class Reference

Class for storing registered options. More...

`#include <IpRegOptions.hpp>`

Inheritance diagram for Ipopt::RegisteredOptions:

[legend]
Collaboration diagram for Ipopt::RegisteredOptions:

[legend]
List of all members.

## Public Types
typedef std::map< std::string, SmartPtr< RegisteredOption > > | RegOptionsList
## Public Member Functions
| DECLARE_STD_EXCEPTION (OPTION_ALREADY_REGISTERED)
const RegOptionsList & | RegisteredOptionsList () const
| Giving access to iteratable representation of the registered options.
| RegisteredOptions ()
| Standard Constructor.
| ~RegisteredOptions ()
| Standard Destructor.
void | SetRegisteringCategory (const std::string &registering_category)
| set the registering class.
std::string | RegisteringCategory ()
| retrieve the value of the current registering category
void | AddNumberOption (const std::string &name, const std::string &short_description, Number default_value, const std::string &long_description="")
| Add a Number option (with no restrictions).
void | AddLowerBoundedNumberOption (const std::string &name, const std::string &short_description, Number lower, bool strict, Number default_value, const std::string &long_description="")
| Add a Number option (with a lower bound).
void | AddUpperBoundedNumberOption (const std::string &name, const std::string &short_description, Number upper, bool strict, Number default_value, const std::string &long_description="")
| Add a Number option (with a upper bound).
void | AddBoundedNumberOption (const std::string &name, const std::string &short_description, Number lower, bool lower_strict, Number upper, bool upper_strict, Number default_value, const std::string &long_description="")
| Add a Number option (with a both bounds).
void | AddIntegerOption (const std::string &name, const std::string &short_description, Index default_value, const std::string &long_description="")
| Add a Integer option (with no restrictions).
void | AddLowerBoundedIntegerOption (const std::string &name, const std::string &short_description, Index lower, Index default_value, const std::string &long_description="")
| Add a Integer option (with a lower bound).
void | AddUpperBoundedIntegerOption (const std::string &name, const std::string &short_description, Index upper, Index default_value, const std::string &long_description="")
| Add a Integer option (with a upper bound).
void | AddBoundedIntegerOption (const std::string &name, const std::string &short_description, Index lower, Index upper, Index default_value, const std::string &long_description="")
| Add a Integer option (with a both bounds).
void | AddStringOption (const std::string &name, const std::string &short_description, const std::string &default_value, const std::vector< std::string > &settings, const std::vector< std::string > &descriptions, const std::string &long_description="")
| Add a String option (with no restrictions).
void | AddStringOption1 (const std::string &name, const std::string &short_description, const std::string &default_value, const std::string &setting1, const std::string &description1, const std::string &long_description="")
| Methods that make adding string options with only a few entries easier.
void | AddStringOption2 (const std::string &name, const std::string &short_description, const std::string &default_value, const std::string &setting1, const std::string &description1, const std::string &setting2, const std::string &description2, const std::string &long_description="")
| set the registering class.
void | AddStringOption3 (const std::string &name, const std::string &short_description, const std::string &default_value, const std::string &setting1, const std::string &description1, const std::string &setting2, const std::string &description2, const std::string &setting3, const std::string &description3, const std::string &long_description="")
| set the registering class.
void | AddStringOption4 (const std::string &name, const std::string &short_description, const std::string &default_value, const std::string &setting1, const std::string &description1, const std::string &setting2, const std::string &description2, const std::string &setting3, const std::string &description3, const std::string &setting4, const std::string &description4, const std::string &long_description="")
| set the registering class.
void | AddStringOption5 (const std::string &name, const std::string &short_description, const std::string &default_value, const std::string &setting1, const std::string &description1, const std::string &setting2, const std::string &description2, const std::string &setting3, const std::string &description3, const std::string &setting4, const std::string &description4, const std::string &setting5, const std::string &description5, const std::string &long_description="")
| set the registering class.
void | AddStringOption6 (const std::string &name, const std::string &short_description, const std::string &default_value, const std::string &setting1, const std::string &description1, const std::string &setting2, const std::string &description2, const std::string &setting3, const std::string &description3, const std::string &setting4, const std::string &description4, const std::string &setting5, const std::string &description5, const std::string &setting6, const std::string &description6, const std::string &long_description="")
| set the registering class.
void | AddStringOption7 (const std::string &name, const std::string &short_description, const std::string &default_value, const std::string &setting1, const std::string &description1, const std::string &setting2, const std::string &description2, const std::string &setting3, const std::string &description3, const std::string &setting4, const std::string &description4, const std::string &setting5, const std::string &description5, const std::string &setting6, const std::string &description6, const std::string &setting7, const std::string &description7, const std::string &long_description="")
| set the registering class.
void | AddStringOption8 (const std::string &name, const std::string &short_description, const std::string &default_value, const std::string &setting1, const std::string &description1, const std::string &setting2, const std::string &description2, const std::string &setting3, const std::string &description3, const std::string &setting4, const std::string &description4, const std::string &setting5, const std::string &description5, const std::string &setting6, const std::string &description6, const std::string &setting7, const std::string &description7, const std::string &setting8, const std::string &description8, const std::string &long_description="")
| set the registering class.
void | AddStringOption9 (const std::string &name, const std::string &short_description, const std::string &default_value, const std::string &setting1, const std::string &description1, const std::string &setting2, const std::string &description2, const std::string &setting3, const std::string &description3, const std::string &setting4, const std::string &description4, const std::string &setting5, const std::string &description5, const std::string &setting6, const std::string &description6, const std::string &setting7, const std::string &description7, const std::string &setting8, const std::string &description8, const std::string &setting9, const std::string &description9, const std::string &long_description="")
| set the registering class.
void | AddStringOption10 (const std::string &name, const std::string &short_description, const std::string &default_value, const std::string &setting1, const std::string &description1, const std::string &setting2, const std::string &description2, const std::string &setting3, const std::string &description3, const std::string &setting4, const std::string &description4, const std::string &setting5, const std::string &description5, const std::string &setting6, const std::string &description6, const std::string &setting7, const std::string &description7, const std::string &setting8, const std::string &description8, const std::string &setting9, const std::string &description9, const std::string &setting10, const std::string &description10, const std::string &long_description="")
| set the registering class.
SmartPtr< const RegisteredOption > | GetOption (const std::string &name)
| Get a registered option - this will return NULL if the option does not exist.
void | OutputOptionDocumentation (const Journalist &jnlst, std::list< std::string > &categories)
| Output documentation for the options - gives a description, etc.
void | OutputLatexOptionDocumentation (const Journalist &jnlst, std::list< std::string > &categories)
| Output documentation in Latex format to include in a latex file.
## Private Attributes
std::string | current_registering_category_
std::map< std::string, SmartPtr< RegisteredOption > > | registered_options_

## Detailed Description

Class for storing registered options.

Used for validation and documentation.

Definition at line 385 of file IpRegOptions.hpp.

## Member Typedef Documentation

typedef std::map<std::string, SmartPtr<RegisteredOption> > Ipopt::RegisteredOptions::RegOptionsList

Definition at line 636 of file IpRegOptions.hpp.

## Constructor & Destructor Documentation

Ipopt::RegisteredOptions::RegisteredOptions | ( |  | ) | `[inline]`

Standard Constructor.

Definition at line 391 of file IpRegOptions.hpp.

Ipopt::RegisteredOptions::~RegisteredOptions | ( |  | ) | `[inline]`

Standard Destructor.

Definition at line 397 of file IpRegOptions.hpp.

## Member Function Documentation

Ipopt::RegisteredOptions::DECLARE_STD_EXCEPTION | ( | OPTION_ALREADY_REGISTERED |  | ) |

void Ipopt::RegisteredOptions::SetRegisteringCategory | ( | const std::string & | registering_category | ) | `[inline]`

set the registering class.

All subsequent options will be added with the registered class

Definition at line 407 of file IpRegOptions.hpp.

References current_registering_category_.

std::string Ipopt::RegisteredOptions::RegisteringCategory | ( |  | ) | `[inline]`

retrieve the value of the current registering category

Definition at line 413 of file IpRegOptions.hpp.

References current_registering_category_.

void Ipopt::RegisteredOptions::AddNumberOption | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | Number | default_value,
|  | const std::string & | long_description = `""` |
| ) |  |  |

Add a Number option (with no restrictions).

void Ipopt::RegisteredOptions::AddLowerBoundedNumberOption | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | Number | lower,
|  | bool | strict,
|  | Number | default_value,
|  | const std::string & | long_description = `""` |
| ) |  |  |

Add a Number option (with a lower bound).

void Ipopt::RegisteredOptions::AddUpperBoundedNumberOption | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | Number | upper,
|  | bool | strict,
|  | Number | default_value,
|  | const std::string & | long_description = `""` |
| ) |  |  |

Add a Number option (with a upper bound).

void Ipopt::RegisteredOptions::AddBoundedNumberOption | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | Number | lower,
|  | bool | lower_strict,
|  | Number | upper,
|  | bool | upper_strict,
|  | Number | default_value,
|  | const std::string & | long_description = `""` |
| ) |  |  |

Add a Number option (with a both bounds).

void Ipopt::RegisteredOptions::AddIntegerOption | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | Index | default_value,
|  | const std::string & | long_description = `""` |
| ) |  |  |

Add a Integer option (with no restrictions).

void Ipopt::RegisteredOptions::AddLowerBoundedIntegerOption | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | Index | lower,
|  | Index | default_value,
|  | const std::string & | long_description = `""` |
| ) |  |  |

Add a Integer option (with a lower bound).

void Ipopt::RegisteredOptions::AddUpperBoundedIntegerOption | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | Index | upper,
|  | Index | default_value,
|  | const std::string & | long_description = `""` |
| ) |  |  |

Add a Integer option (with a upper bound).

void Ipopt::RegisteredOptions::AddBoundedIntegerOption | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | Index | lower,
|  | Index | upper,
|  | Index | default_value,
|  | const std::string & | long_description = `""` |
| ) |  |  |

Add a Integer option (with a both bounds).

void Ipopt::RegisteredOptions::AddStringOption | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | const std::string & | default_value,
|  | const std::vector< std::string > & | settings,
|  | const std::vector< std::string > & | descriptions,
|  | const std::string & | long_description = `""` |
| ) |  |  |

Add a String option (with no restrictions).

void Ipopt::RegisteredOptions::AddStringOption1 | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | const std::string & | default_value,
|  | const std::string & | setting1,
|  | const std::string & | description1,
|  | const std::string & | long_description = `""` |
| ) |  |  |

Methods that make adding string options with only a few entries easier.

void Ipopt::RegisteredOptions::AddStringOption2 | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | const std::string & | default_value,
|  | const std::string & | setting1,
|  | const std::string & | description1,
|  | const std::string & | setting2,
|  | const std::string & | description2,
|  | const std::string & | long_description = `""` |
| ) |  |  |

set the registering class.

All subsequent options will be added with the registered class

void Ipopt::RegisteredOptions::AddStringOption3 | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | const std::string & | default_value,
|  | const std::string & | setting1,
|  | const std::string & | description1,
|  | const std::string & | setting2,
|  | const std::string & | description2,
|  | const std::string & | setting3,
|  | const std::string & | description3,
|  | const std::string & | long_description = `""` |
| ) |  |  |

set the registering class.

All subsequent options will be added with the registered class

void Ipopt::RegisteredOptions::AddStringOption4 | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | const std::string & | default_value,
|  | const std::string & | setting1,
|  | const std::string & | description1,
|  | const std::string & | setting2,
|  | const std::string & | description2,
|  | const std::string & | setting3,
|  | const std::string & | description3,
|  | const std::string & | setting4,
|  | const std::string & | description4,
|  | const std::string & | long_description = `""` |
| ) |  |  |

set the registering class.

All subsequent options will be added with the registered class

void Ipopt::RegisteredOptions::AddStringOption5 | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | const std::string & | default_value,
|  | const std::string & | setting1,
|  | const std::string & | description1,
|  | const std::string & | setting2,
|  | const std::string & | description2,
|  | const std::string & | setting3,
|  | const std::string & | description3,
|  | const std::string & | setting4,
|  | const std::string & | description4,
|  | const std::string & | setting5,
|  | const std::string & | description5,
|  | const std::string & | long_description = `""` |
| ) |  |  |

set the registering class.

All subsequent options will be added with the registered class

void Ipopt::RegisteredOptions::AddStringOption6 | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | const std::string & | default_value,
|  | const std::string & | setting1,
|  | const std::string & | description1,
|  | const std::string & | setting2,
|  | const std::string & | description2,
|  | const std::string & | setting3,
|  | const std::string & | description3,
|  | const std::string & | setting4,
|  | const std::string & | description4,
|  | const std::string & | setting5,
|  | const std::string & | description5,
|  | const std::string & | setting6,
|  | const std::string & | description6,
|  | const std::string & | long_description = `""` |
| ) |  |  |

set the registering class.

All subsequent options will be added with the registered class

void Ipopt::RegisteredOptions::AddStringOption7 | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | const std::string & | default_value,
|  | const std::string & | setting1,
|  | const std::string & | description1,
|  | const std::string & | setting2,
|  | const std::string & | description2,
|  | const std::string & | setting3,
|  | const std::string & | description3,
|  | const std::string & | setting4,
|  | const std::string & | description4,
|  | const std::string & | setting5,
|  | const std::string & | description5,
|  | const std::string & | setting6,
|  | const std::string & | description6,
|  | const std::string & | setting7,
|  | const std::string & | description7,
|  | const std::string & | long_description = `""` |
| ) |  |  |

set the registering class.

All subsequent options will be added with the registered class

void Ipopt::RegisteredOptions::AddStringOption8 | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | const std::string & | default_value,
|  | const std::string & | setting1,
|  | const std::string & | description1,
|  | const std::string & | setting2,
|  | const std::string & | description2,
|  | const std::string & | setting3,
|  | const std::string & | description3,
|  | const std::string & | setting4,
|  | const std::string & | description4,
|  | const std::string & | setting5,
|  | const std::string & | description5,
|  | const std::string & | setting6,
|  | const std::string & | description6,
|  | const std::string & | setting7,
|  | const std::string & | description7,
|  | const std::string & | setting8,
|  | const std::string & | description8,
|  | const std::string & | long_description = `""` |
| ) |  |  |

set the registering class.

All subsequent options will be added with the registered class

void Ipopt::RegisteredOptions::AddStringOption9 | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | const std::string & | default_value,
|  | const std::string & | setting1,
|  | const std::string & | description1,
|  | const std::string & | setting2,
|  | const std::string & | description2,
|  | const std::string & | setting3,
|  | const std::string & | description3,
|  | const std::string & | setting4,
|  | const std::string & | description4,
|  | const std::string & | setting5,
|  | const std::string & | description5,
|  | const std::string & | setting6,
|  | const std::string & | description6,
|  | const std::string & | setting7,
|  | const std::string & | description7,
|  | const std::string & | setting8,
|  | const std::string & | description8,
|  | const std::string & | setting9,
|  | const std::string & | description9,
|  | const std::string & | long_description = `""` |
| ) |  |  |

set the registering class.

All subsequent options will be added with the registered class

void Ipopt::RegisteredOptions::AddStringOption10 | ( | const std::string & | name,
|  | const std::string & | short_description,
|  | const std::string & | default_value,
|  | const std::string & | setting1,
|  | const std::string & | description1,
|  | const std::string & | setting2,
|  | const std::string & | description2,
|  | const std::string & | setting3,
|  | const std::string & | description3,
|  | const std::string & | setting4,
|  | const std::string & | description4,
|  | const std::string & | setting5,
|  | const std::string & | description5,
|  | const std::string & | setting6,
|  | const std::string & | description6,
|  | const std::string & | setting7,
|  | const std::string & | description7,
|  | const std::string & | setting8,
|  | const std::string & | description8,
|  | const std::string & | setting9,
|  | const std::string & | description9,
|  | const std::string & | setting10,
|  | const std::string & | description10,
|  | const std::string & | long_description = `""` |
| ) |  |  |

set the registering class.

All subsequent options will be added with the registered class

SmartPtr<const RegisteredOption> Ipopt::RegisteredOptions::GetOption | ( | const std::string & | name | ) |

Get a registered option - this will return NULL if the option does not exist.

void Ipopt::RegisteredOptions::OutputOptionDocumentation | ( | const Journalist & | jnlst,
|  | std::list< std::string > & | categories |
| ) |  |  |

Output documentation for the options - gives a description, etc.

void Ipopt::RegisteredOptions::OutputLatexOptionDocumentation | ( | const Journalist & | jnlst,
|  | std::list< std::string > & | categories |
| ) |  |  |

Output documentation in Latex format to include in a latex file.

const RegOptionsList& Ipopt::RegisteredOptions::RegisteredOptionsList | ( |  | ) | const`[inline]`

Giving access to iteratable representation of the registered options.

Definition at line 640 of file IpRegOptions.hpp.

References registered_options_.

## Member Data Documentation

std::string Ipopt::RegisteredOptions::current_registering_category_`[private]`

Definition at line 646 of file IpRegOptions.hpp.

Referenced by RegisteringCategory(), and SetRegisteringCategory().

std::map<std::string, SmartPtr<RegisteredOption> > Ipopt::RegisteredOptions::registered_options_`[private]`

Definition at line 647 of file IpRegOptions.hpp.

Referenced by RegisteredOptionsList().

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.7.1/Ipopt/src/Common/IpRegOptions.hpp